// Auto-generated. Do not edit!

// (in-package rc_pick_client.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Box = require('./Box.js');
let Rectangle = require('./Rectangle.js');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class LoadCarrier {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.id = null;
      this.outer_dimensions = null;
      this.inner_dimensions = null;
      this.rim_thickness = null;
      this.pose = null;
      this.overfilled = null;
    }
    else {
      if (initObj.hasOwnProperty('id')) {
        this.id = initObj.id
      }
      else {
        this.id = '';
      }
      if (initObj.hasOwnProperty('outer_dimensions')) {
        this.outer_dimensions = initObj.outer_dimensions
      }
      else {
        this.outer_dimensions = new Box();
      }
      if (initObj.hasOwnProperty('inner_dimensions')) {
        this.inner_dimensions = initObj.inner_dimensions
      }
      else {
        this.inner_dimensions = new Box();
      }
      if (initObj.hasOwnProperty('rim_thickness')) {
        this.rim_thickness = initObj.rim_thickness
      }
      else {
        this.rim_thickness = new Rectangle();
      }
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.PoseStamped();
      }
      if (initObj.hasOwnProperty('overfilled')) {
        this.overfilled = initObj.overfilled
      }
      else {
        this.overfilled = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type LoadCarrier
    // Serialize message field [id]
    bufferOffset = _serializer.string(obj.id, buffer, bufferOffset);
    // Serialize message field [outer_dimensions]
    bufferOffset = Box.serialize(obj.outer_dimensions, buffer, bufferOffset);
    // Serialize message field [inner_dimensions]
    bufferOffset = Box.serialize(obj.inner_dimensions, buffer, bufferOffset);
    // Serialize message field [rim_thickness]
    bufferOffset = Rectangle.serialize(obj.rim_thickness, buffer, bufferOffset);
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.pose, buffer, bufferOffset);
    // Serialize message field [overfilled]
    bufferOffset = _serializer.bool(obj.overfilled, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type LoadCarrier
    let len;
    let data = new LoadCarrier(null);
    // Deserialize message field [id]
    data.id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [outer_dimensions]
    data.outer_dimensions = Box.deserialize(buffer, bufferOffset);
    // Deserialize message field [inner_dimensions]
    data.inner_dimensions = Box.deserialize(buffer, bufferOffset);
    // Deserialize message field [rim_thickness]
    data.rim_thickness = Rectangle.deserialize(buffer, bufferOffset);
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [overfilled]
    data.overfilled = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.id);
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.pose);
    return length + 69;
  }

  static datatype() {
    // Returns string type for a message object
    return 'rc_pick_client/LoadCarrier';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '4720337d8658ed352ab731b8e8485280';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # This represents a load carrier by its geometry and its pose
    
    string id
    
    # Required
    Box outer_dimensions
    
    # Required
    Box inner_dimensions
    
    # Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
    Rectangle rim_thickness
    
    geometry_msgs/PoseStamped pose
    
    # True if a detected load carrier is overfilled. Ignored on setting load carrier.
    bool overfilled
    
    ================================================================================
    MSG: rc_pick_client/Box
    # Definition of a box
    
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: rc_pick_client/Rectangle
    # Definition of a rectangle
    
    float64 x
    float64 y
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new LoadCarrier(null);
    if (msg.id !== undefined) {
      resolved.id = msg.id;
    }
    else {
      resolved.id = ''
    }

    if (msg.outer_dimensions !== undefined) {
      resolved.outer_dimensions = Box.Resolve(msg.outer_dimensions)
    }
    else {
      resolved.outer_dimensions = new Box()
    }

    if (msg.inner_dimensions !== undefined) {
      resolved.inner_dimensions = Box.Resolve(msg.inner_dimensions)
    }
    else {
      resolved.inner_dimensions = new Box()
    }

    if (msg.rim_thickness !== undefined) {
      resolved.rim_thickness = Rectangle.Resolve(msg.rim_thickness)
    }
    else {
      resolved.rim_thickness = new Rectangle()
    }

    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.PoseStamped.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.PoseStamped()
    }

    if (msg.overfilled !== undefined) {
      resolved.overfilled = msg.overfilled;
    }
    else {
      resolved.overfilled = false
    }

    return resolved;
    }
};

module.exports = LoadCarrier;
